/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ACCOUNT_H
#define  _ACCOUNT_H


#include <stdio.h>
#include "nodedblk.h"


class Position : public NodeDoubleLink
  {
  public:
    char  sName[61];
    char  sSymbol[11];
    char  sPurchDate[11];
    double  dPurchPrice;
    double  dPurchQty;
    double  dCurrPrice;
    double  dCurrQty;

  protected:
  private:
  };

class MutualFund : public Position
  {
  public:
    virtual MutualFund *Next( )               { return (MutualFund *)pNext; }

  protected:
  private:
  };

class Stock : public Position
  {
  public:
    virtual Stock *Next( )                    { return (Stock *)pNext; }

  protected:
  private:
  };

class Transaction : public NodeDoubleLink
  {
  public:
    char  sDate[11];
    char  sDesc[81];
    double  dQty;
    double  dPrice;
    double  dAmount;
    double  dBalance;

    virtual Transaction *Next( )               { return (Transaction *)pNext; }

  protected:
  private:
  };

class Account
  {
  public:
    Stock       *pStocks;
    MutualFund  *pFunds;
    Transaction *pTransacts;

    Account( char *psFile);
    ~Account( );

    double TotalCostBasis( );
    double TotalCurrValue( );
    double TotalMutualFunds( );
    double TotalStocks( );

    char  *AccountNo( )       { return "43-5479653"; }
    double EstTaxInc( )       { return 18525.54; }
    double EstNontaxInc( )    { return  3956.29; }
    char  *Name( )            { return "<your name here>"; }
    double TotalCash( )       { return  9355.08; }
    double TotalCDs( )        { return     0.00; }
    double TotalCorpBonds( )  { return     0.00; }
    double TotalGovBonds( )   { return     0.00; }
    double TotalRealized( )   { return 14542.54; }
    double TotalUnrealized( ) { return TotalCurrValue( ) - TotalCostBasis( ); }
    double YTDNontaxInc( )    { return TotalRealized( ) - YTDTaxInc( ); }
    double YTDTaxInc( )       { return 12173.83; }

  protected:
    void         AddBogusInfo( char *psFile);
    MutualFund  *GetFund( FILE *pf);
    Stock       *GetStock( FILE *pf);
    Transaction *GetTransaction( FILE *pf);

  private:
  };


#endif    //---- _ACCOUNT_H
