/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _NODEDBLK_H
#define  _NODEDBLK_H


#include <new.h>
#include "oreports.h"


//#define  MAXORBLOCKS  1000


class OREXPORT NodeDoubleLink
  {
  public:
    NodeDoubleLink   *pNext, *pPrev;

    NodeDoubleLink( );
    virtual ~NodeDoubleLink( );

    virtual void   AddAtEnd( NodeDoubleLink *&pNode);
    virtual void   DeleteAll( );
    virtual void   InsertAfter( NodeDoubleLink *pNode);
    virtual void   InsertBefore( NodeDoubleLink *pNode);
    virtual NodeDoubleLink *Last( );
    virtual NodeDoubleLink *Remove( NodeDoubleLink *&pListHead);
    virtual void   Unlink( );

#ifdef  MAXORBLOCKS
    void *operator new( size_t bytes);
    void  operator delete( void *pv);
#endif

  protected:
#ifdef  MAXORBLOCKS
    static  ORBool  bBlocksInitialized;
    static  char   *apBlocks[MAXORBLOCKS];
    static  int     anBlocks[MAXORBLOCKS];

    static  void   AddMemory( char *pac, int bytes);
    static  void   CheckMemory( );
    static  void   FreeMemory( char *pac);
#endif    //---- MAXORBLOCKS

  private:
  };


#endif  //---- _NODEDBLK_H
