/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORACCT_H
#define  _ORACCT_H


#include "account.h"
#include "orreport.h"


//---- developer defined Font Ids
#define  IDFntA_Arial10     3101
#define  IDFntA_Arial10B    3102
#define  IDFntA_Arial12     3103
#define  IDFntA_Arial14     3104
#define  IDFntA_Arial18     3105
#define  IDFntA_Arial20     3106

//---- developer defined Pen Ids
#define  IDPenA_2PtsInside    3101
#define  IDPenA_1Pt           3102

//---- developer defined Column Ids
#define  IDColA_Center      3101

#define  IDColA_CostBasis       3110
#define  IDColA_CurrValue       3111
#define  IDColA_GLReal          3112
#define  IDColA_GLMid           3113
#define  IDColA_GLUnreal        3114
#define  IDColA_TaxInc          3115
#define  IDColA_NontaxInc       3116

#define  IDColA_Amount       3120
#define  IDColA_Bars         3121

#define  IDColA_SMFPrchDate   3130
#define  IDColA_SMFName       3131
#define  IDColA_SMFGainLoss   3132
#define  IDColA_SMFCurrVal    3133
#define  IDColA_SMFCurrPri    3134
#define  IDColA_SMFCurrQty    3135
#define  IDColA_SMFPrchCost   3136
#define  IDColA_SMFPrchPri    3137
#define  IDColA_SMFPrchQty    3138
#define  IDColA_SMFSymbol     3139

#define  IDColA_TSDate       3140
#define  IDColA_TSDesc       3141
#define  IDColA_TSShares     3142
#define  IDColA_TSPrice      3143
#define  IDColA_TSCredDeb    3144
#define  IDColA_TSBalance    3145

#define  FILE_ACCOUNT_DATA    "Account.Txt"


//---- developer defined report class for ORDemo Investment Account Report
class OREXPORT ORReport_Account : public ORReport
  {
  public:
    ORReport_Account( char *psTitle_, ABORTPROC lpfnAbortProc_,
                      HWND hDlgPrint_);
    virtual ~ORReport_Account( );

    virtual long   Instantiate( ORPrintDC *pPrintDC);
    virtual long   InstantiateChildren( );
    virtual long   InstantiateColumns( );
    virtual long   InstantiateFonts( );
    virtual long   InstantiatePageLayers( );

            char  *DateBegin( )         { return  "8/1/95"; }
            char  *DateEnd( )           { return "8/31/95"; }

  protected:
    HWND      hDlgPrint;
    Account  *pAcct;

    virtual long   Initialize( );
    virtual long   PrintPage( );

  private:
  };


//---- developer defined Page Header Layer
class ORLayer_AHeader : public ORLayer
  {
  public:
    ORLayer_AHeader( ORReport_Account *pRepAcct_, long lAttr_, Account *pAcct_);

  protected:
    ORReport_Account  *pRepAcct;
    Account           *pAcct;

    virtual long InstantiateChildren( );

  private:
  };


//---- developer defined Body Layer
class ORLayer_ATitle : public ORLayer
  {
  public:
    ORLayer_ATitle( ORLayer *pL, char *psTitle);

    virtual long  PostPrint( ORDC *pDC);

  protected:
    char  sTitle[81];

    virtual long  InstantiateChildren( );

  private:
  };


//---- developer defined Body Layer
class ORLayer_AcctSumm : public ORLayer
  {
  public:
    ORLayer_AcctSumm( ORReport *pRep, Account *pAcct_);

    virtual long  PostPrint( ORDC *pDC);

  protected:
    Account  *pAcct;

    virtual long  InstantiateChildren( );

  private:
  };


//---- developer defined Body Layer

#define  MAXINFOS    6

class ORLayer_AcctAlloc : public ORLayer
  {
  typedef struct
    {
    char    sLabel[31];
    double  dAmount;
    double  dPct;
    } LayerInfo;

  public:
    ORLayer_AcctAlloc( ORReport *pRep, Account *pAcct_);

    virtual long  PostPrint( ORDC *pDC);

  protected:
    Account   *pAcct;
    LayerInfo  astInfo[MAXINFOS];

            void  InitializeInfo( );
    virtual long  InstantiateChildren( );

  private:
  };


//---- developer defined Body Layer
class ORLayer_StockSummary : public ORLayer
  {
  public:
    ORLayer_StockSummary( ORReport *pRep, Account *pAcct_);

    virtual long  PostPrint( ORDC *pDC);

  protected:
    Account   *pAcct;

    virtual long  InstantiateChildren( );

  private:
  };


//---- developer defined Body Layer
class ORLayer_MFSummary : public ORLayer
  {
  public:
    ORLayer_MFSummary( ORReport *pRep, Account *pAcct_);

    virtual long  PostPrint( ORDC *pDC);

  protected:
    Account   *pAcct;

    virtual long  InstantiateChildren( );

  private:
  };


//---- developer defined Body Layer
class ORLayer_TransSumm : public ORLayer
  {
  public:
    ORLayer_TransSumm( ORReport *pRep, Account *pAcct_);

    virtual long  PostPrint( ORDC *pDC);

  protected:
    Account   *pAcct;

    virtual long  InstantiateChildren( );

  private:
  };


#endif    //---- _ORACCT_H
