/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORCOLUMN_H
#define  _ORCOLUMN_H


#include "orobject.h"


class OREXPORT ORReport;


class OREXPORT ORColumn : public ORObject
  {
  public:
    ORColumn( ORReport *pParentRep_, long lId_, char *psTextWidth_,
              long lFontId_, long lMarginLeftPts_ = 0, long lMarginRightPts_ = 0,
              long lRelColId = 0, long lAttr_ = 0);
    ORColumn( ORReport *pParentRep_, long lId_, long lWidthPts_,
              long lMarginLeftPts_ = 0, long lMarginRightPts_ = 0,
              long lRelColId = 0, long lAttr_ = 0);
    virtual ~ORColumn( );

    virtual long   Left( short shInOut = OROUTSIDE);
    virtual long   Position( ORRect &rectRemain);
    virtual long   Right( short shInOut = OROUTSIDE);
    virtual long   Size( ORRect &rectRemain, ORDC *pDC);
    virtual long   SizeAndPosition( ORRect &rectRemain, ORDC *pDC);
    virtual ORBool TypeOf( long lType);
    virtual long   Width( short shInOut = OROUTSIDE);

    virtual long   MarginLeft( )                 { return lMarginLeftPix; }
    virtual long   MarginRight( )                { return lMarginRightPix; }
            ORColumn *Next( )                    { return (ORColumn *)pNext; }
            ORColumn *Prev( )                    { return (ORColumn *)pPrev; }
    virtual long   Type( )                       { return TYPE_ORCOLUMN; }

  protected:
    ORReport  *pParentRep;
    ORColumn  *pRelCol;
    long    lFontId;
    long    lMarginLeftPts,lMarginRightPts, lWidthPts;
    long    lMarginLeftPix,lMarginRightPix;
    char   *psWidthText;

            void   CalcMargins( );
            ORDC  *DC( );

  private:
  };


#endif    //---- _ORCOLUMN_H
