/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORDC_H
#define  _ORDC_H


#include "orobject.h"


//---- this is required for 16-bit code
#ifndef  PHYSICALWIDTH
#define  PHYSICALWIDTH    110
#define  PHYSICALHEIGHT   111
#endif


#define  ORPRV_STARTDOC            1
#define  ORPRV_BRUSH               2
#define  ORPRV_FONT                3
#define  ORPRV_PEN                 4
#define  ORPRV_SELECTBRUSH         5
#define  ORPRV_SELECTSTOCKBRUSH    6
#define  ORPRV_SELECTFONT          7
#define  ORPRV_SELECTSTOCKFONT     8
#define  ORPRV_SELECTPEN           9
#define  ORPRV_SELECTSTOCKPEN     10
#define  ORPRV_LINETO             11
#define  ORPRV_MOVETOEX           12
#define  ORPRV_RECTANGLE          13
#define  ORPRV_ROUNDRECT          14
#define  ORPRV_TEXTOUT            15
#define  ORPRV_SETBKMODE          16
#define  ORPRV_SETTEXTALIGN       17
#define  ORPRV_ENDDOC             18
#define  ORPRV_STARTPAGE          19
#define  ORPRV_ENDPAGE            20


typedef struct
  {
  long  lType;
  short shSize;
  } OREndDoc;

typedef struct
  {
  long  lType;
  short shSize;
  } OREndPage;

typedef struct
  {
  long  lType;
  short shSize;
  long  lX;
  long  lY;
  } ORLineTo;

typedef struct
  {
  long  lType;
  short shSize;
  long  lX;
  long  lY;
  } ORMoveToEx;

typedef struct
  {
  long  lType;
  short shSize;
  long  lLeft;
  long  lTop;
  long  lRight;
  long  lBottom;
  } ORRectangle;

typedef struct
  {
  long  lType;
  short shSize;
  long  lLeft;
  long  lTop;
  long  lRight;
  long  lBottom;
  long  lEllipseWidth;
  long  lEllipseHeight;
  } ORRoundRect;

typedef struct
  {
  long  lType;
  short shSize;
  long  lId;
  } ORSelectBrush;

typedef struct
  {
  long  lType;
  short shSize;
  long  lId;
  } ORSelectFont;

typedef struct
  {
  long  lType;
  short shSize;
  long  lId;
  } ORSelectPen;

typedef struct
  {
  long  lType;
  short shSize;
  long  lBkMode;
  } ORSetBkMode;

typedef struct
  {
  long   lType;
  short  shSize;
  unsigned long  ulTA;
  } ORSetTextAlign;

typedef struct
  {
  long  lType;
  short shSize;
  char  sDocName[MAXDITITLE+1];
  char  sPrinter[MAXORDCSTRING+1];
  char  sDriver[MAXORDCSTRING+1];
  char  sPort[MAXORDCSTRING+1];
  long  lPaperWidth;
  long  lPaperHeight;
  long  lPrintableWidth;
  long  lPrintableHeight;
  short shLogPixelsX;
  short shLogPixelsY;
  } ORStartDoc;

typedef struct
  {
  long  lType;
  short shSize;
  long  lId;
  struct        //-- LOGBRUSH
    {
    unsigned long  lbStyle;
    unsigned long  lbColor;
    long           lbHatch;
    } stLB;
  } ORSaveBrush;

typedef struct
  {
  long  lType;
  short shSize;
  long  lId;
  struct        //-- LOGFONT
    {
    long           lfHeight;
    long           lfWidth;
    long           lfEscapement;
    long           lfOrientation;
    long           lfWeight;
    unsigned char  lfItalic;
    unsigned char  lfUnderline;
    unsigned char  lfStrikeOut;
    unsigned char  lfCharSet;
    unsigned char  lfOutPrecision;
    unsigned char  lfClipPrecision;
    unsigned char  lfQuality;
    unsigned char  lfPitchAndFamily;
    char           lfFaceName[LF_FACESIZE];
    } stLF;
  double   dPointsHeight;
  double   dPointsWidth;
  } ORSaveFont;

typedef struct
  {
  long  lType;
  short shSize;
  long  lId;
  struct        //-- LOGPEN
    {
    unsigned long  lopnStyle;
    long           lopnWidthX;
    long           lopnWidthY;
    unsigned long  lopnColor;
    } stLP;
  double  dPointsWidth;
  } ORSavePen;

typedef struct
  {
  long  lType;
  short shSize;
  long  lNextPage;
  } ORStartPage;

typedef struct
  {
  long  lType;
  short shSize;
  long  lX;
  long  lY;
  } ORTextOut;


class OREXPORT ORBrush;
class OREXPORT ORFont;
class OREXPORT ORPen;


class OREXPORT ORDC
  {
  public:
    ORDC( );
    virtual ~ORDC( );

            int    GetDeviceCaps( int nIndex);
    virtual int    GetPrinterDeviceCaps( int nIndex);
            long   GetTextExtentPoint( char *ps, int nNChars, SIZE &stSize);
            long   GetTextMetrics( TEXTMETRIC &tm);
    virtual long   LineTo( long lX, long lY);
    virtual long   MoveToEx( long lX, long lY, POINT *pPoint = NULL);
    virtual long   Rectangle( long lLeft, long lTop,
                              long lRight, long lBottom);
            void   RestoreAll( );
    virtual long   RoundRect( long lLeft, long lTop, long lRight, long lBottom,
                              long lEllipseWidth = 30,
                              long lEllipseHeight = 30);
    virtual HBRUSH Select( ORBrush *pBrush);
    virtual HFONT  Select( ORFont *pFont);
    virtual HPEN   Select( ORPen *pPen);
    virtual HBRUSH SelectStockBrush( int nStockBrush);
    virtual HFONT  SelectStockFont( int nStockFont);
    virtual HPEN   SelectStockPen( int nStockPen);
    virtual long   SetBkMode( int nBkMode);
    virtual long   SetTextAlign( UINT uTA);
    virtual long   TextOut( long lX, long lY, char *psText, int nChars);
    virtual ORBool TypeOf( long lType);

    virtual long   AbortDoc( )                 { return 0; }
    virtual long   EndDoc( )                   { return 0; }
    virtual long   EndPage( )                  { return 0; }
            HDC    Handle( )                   { return hDC; }
            ORBool IsValid( )                  { return (ORBool)((hDC) ? TRUE : FALSE); }
            int    PrevBkMode( )               { return nPrevBkMode; }
            UINT   PrevTextAlign( )            { return uPrevTextAlign; }
    virtual long   SaveGDIObjects( ORBrush *, ORFont *, ORPen *)  { return 0; }
    virtual long   SetAbortProc( ABORTPROC)    { return 0; }
    virtual long   StartDoc( DOCINFO &)        { return 0; }
    virtual long   StartPage( )                { return 0; }
    virtual long   Type( )                     { return TYPE_ORDC; }

  protected:
    HDC      hDC;
    HBRUSH   hOrigBrush;
    HFONT    hOrigFont;
    HPEN     hOrigPen;
    ORBrush *pCurrBrush;
    ORFont  *pCurrFont;
    ORPen   *pCurrPen;
    POINT    ptLast;

    UINT  uPrevTextAlign;
    int   nPrevBkMode;

  private:
  };


#endif    //---- _ORDC_H
