/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORELEMNT_H
#define  _ORELEMNT_H


#include "orobject.h"


class OREXPORT ORLayer;
class OREXPORT ORColumn;


class OREXPORT ORElement : public ORObject
  {
  public:
    ORElement( ORLayer *pParentLayer, long lId_, long lAttr_, long lRelId_ = 0);
    virtual ~ORElement( );

    virtual void   AddRelative( ORElement *pRelElem);
    virtual void   AddY( long lDY);
            ORElement *ElementRel( long lId);
    virtual long   HeightRel( ORRect *pRect = NULL);
    virtual long   Position( ORRect &rectBounds);
    virtual void   PositionRel( ORElement *pParentElem);
            void   PositionRelCol( );
    virtual long   Print( ORDC *pDC);
    virtual long   Size( ORRect &, ORDC *);
    virtual ORBool TypeOf( long lType);

            ORElement *Next( )            { return (ORElement *)pNext; }
            ORElement *Prev( )            { return (ORElement *)pPrev; }
    virtual long   Type( )                { return TYPE_ORELEMENT; }

    virtual char  *Name( )                { return "ORElement"; }

  protected:
    ORLayer    *pParentLayer;
    ORElement  *pRelElems;
    ORColumn   *pRelCol;
    long        lRelParentType;

            long   FindRelative( long lRelId);
            long   Position_RelElems( );
    virtual long   Size_RelElems( ORRect &rectRemain, ORDC *pDC);
    virtual long   Size_Self( ORRect &rectRemain, ORDC *pDC);

  private:
  };


#endif    //---- _ORELEMNT_H
