/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORFONT_H
#define  _ORFONT_H


#include <iostream.h>
#include "orobject.h"


class OREXPORT ORContext;


class OREXPORT ORFont : public ORObject
  {
  public:
    ORFont( ORContext *pParentContext_, long lId_, char *psFace = NULL,
            double dPointsHeight = 0, double dPointsWidth = 0,
            int nEscapement = 0, int nOrientation = 0, int nWeight = 0,
            BYTE pitchAndFamily = 0, BYTE italic = 0, BYTE underline = 0,
            BYTE strikeout = 0, BYTE charSet = 0, BYTE outputPrecision = 0,
            BYTE clipPrecision = 0, BYTE quality = 0);
    ORFont( ORContext *pParentContext_, long lId_,
            double dPointsHeight, double dPointsWidth, LOGFONT &stLF_);
    ORFont( ORContext *pParentContext_, istream &is);
    virtual ~ORFont( );

            ORBool  Save( ostream &os);
    virtual ORBool  TypeOf( long lType);

    virtual HFONT   Handle( )                     { return hFont; }
    virtual long    Height( short = OROUTSIDE)    { return lHeight; }
            ORFont *Next( )                       { return (ORFont *)pNext; }
            ORFont *Prev( )                       { return (ORFont *)pPrev; }
    virtual long    Type( )                       { return TYPE_ORFONT; }

  protected:
    ORContext *pParentContext;
    LOGFONT    stLF;
    HFONT      hFont;
    double     dPointsHeight;
    double     dPointsWidth;
    long   lHeight,
           lAscent,
           lDescent;

            void    CreateFont( );
            ORBool  Load( istream &is);

  private:
  };


#endif    //---- _ORFONT_H
