/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORLAYER_H
#define  _ORLAYER_H


#include "orelemnt.h"


class OREXPORT ORBrush;
class OREXPORT ORColumn;
class OREXPORT ORFont;
class OREXPORT ORPen;
class OREXPORT ORReport;


class OREXPORT ORLayer : public ORObject
  {
  public:
    ORLayer( ORLayer *pParentLayer,
             long lMarginTopPts_ = 0, long lMarginBottomPts_ = 0,
             ORBool bDontDelete_ = FALSE);
    ORLayer( ORReport *pParentRep, long lAttr_ = 0,
             long lMarginTopPts_ = 0, long lMarginBottomPts_ = 0,
             ORBool bDontDelete_ = FALSE);
    virtual ~ORLayer( );

            long   Add( ORObject *pChild);
    virtual void   AddY( long lDY);
    virtual long   Bottom( short shInOut = OROUTSIDE);
            ORColumn *Column( long lId);
            ORBool ContainsUnprinted( );
            ORBool Deletable( );
            void   DeletePrinted( );
            ORElement *Element( long lId);
            ORBool FirstOnPage( );
            ORFont *Font( long lId);
    virtual long   Height( short shInOut = OROUTSIDE);
            long   Instantiate( );
            long   IsPageFull( ORBool bForcePageEject_ = FALSE);
            ORBool PageLayer( );
    virtual long   Print( ORDC *pDC);
            ORReport *Report( );
    virtual long   SetPrint( ORRect &rectRemain, ORBool &bPageEject);
            void   SetPrint( ORBool b = TRUE);
    virtual void   SetY( long lY);
    virtual long   SizeAndPosition( ORRect &rectRemain, ORDC *pDC);
            ORBool StringId( char *psId_);
    virtual long   Top( short shInOut = OROUTSIDE);
    virtual ORBool TypeOf( long lType);

            ORBool Breakable( )               { return bBreakable; }
            void   Breakable( ORBool b)       { bBreakable = b; }
            void   CheckPageFull( ORBool b)   { bCheckPageFull = b; }
            ORBool DontDelete( )              { return bDontDelete; }
            void   DontDelete( ORBool b)      { bDontDelete = b; }
            ORBool ForcePageEject( )          { return bForcePageEject; }
            void   ForcePageEject( ORBool b)  { bForcePageEject = b; }
            ORBool IsInstanceComplete( )      { return bInstanceComplete; }
    virtual long   MarginBottom( )            { return lMarginBottomPix; }
    virtual long   MarginTop( )               { return lMarginTopPix; }
            ORLayer *Next( )                  { return (ORLayer *)pNext; }
            void   PageLayer( ORBool b)       { bPageLayer = b; }
    virtual long   PostPrint( ORDC *pDC)      { return 0; }
    virtual long   PrePrint( ORDC *pDC)       { return 0; }
            ORLayer *Prev( )                  { return (ORLayer *)pPrev; }
            ORBool Printed( )                 { return bPrinted; }
            char  *StringId( )                { return psId; }
    virtual long   Type( )                    { return TYPE_ORLAYER; }

    virtual char  *Name( )                    { return "ORLayer"; }

  protected:
    ORLayer   *pParentLayer;
    ORReport  *pParentRep;
    ORObject  *pChildren;
    ORBool     bBreakable,
               bCheckPageFull,
               bDontDelete,
               bPrint,
               bPrinted,
               bPageLayer,
               bForcePageEject,
               bInstanceComplete;
    char      *psId;
    long       lMarginTopPts,lMarginBottomPts,
               lMarginTopPix,lMarginBottomPix;

            ORBrush *Brush( long lId);
            long   CalcMargin( long lMarginPts);
            long   CallInstantiateOnChildren( );
            ORBool Child_InstComplt_ForcePgEjct( );
            ORDC  *DC( );
            long   InstanceComplete( );
            long   InstantiatePreviousSiblings( );
            ORPen *Pen( long lId);
            long   Print_Layers( ORDC *pDC);
            long   Print_Elements( ORDC *pDC);
            long   SetPrint_Elements( ORRect &rectRemain);
            long   SetPrint_Layers( ORRect &rectRemain, ORBool &bPageEject);
    virtual long   SizeAndPosition_Elems( ORRect &rectRemain, ORDC *pDC);
    virtual long   SizeAndPosition_Elems_CalcHt( );
    virtual long   SizeAndPosition_Layers( ORRect &rectRemain, ORDC *pDC);

    virtual long   InstantiateChildren( )     { return 0; }
    virtual long   PostInstantiate( )         { return 0; }
    virtual long   PreInstantiate( )          { return 0; }

  private:
  };


#endif    //---- _ORLAYER_H
