/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORPACKLS_H
#define  _ORPACKLS_H


#include "orreport.h"
#include "packlist.h"


//---- developer defined Font Ids
#define  IDFntP_Arial10         2104
#define  IDFntP_Arial12         2101
#define  IDFntP_Arial16         2102
#define  IDFntP_Arial24         2103

//---- developer defined Pen Ids
#define  IDPenP_2PtsInside    2101
#define  IDPenP_1Pt           2102

//---- developer defined Column Ids
#define  IDColP_LeftHalf       2101
#define  IDColP_RightHalf      2102
#define  IDColP_ItemNo         2103
#define  IDColP_Quantity       2104
#define  IDColP_Code           2105
#define  IDColP_Desc           2106
#define  IDColP_UnitPrice      2107
#define  IDColP_Notes          2108


class PackingList;
class OREXPORT ORDC;


class OREXPORT ORReport_PackList: public ORReport
  {
  public:
    ORReport_PackList( char *psTitle_, ABORTPROC lpfnAbortProc_, 
                       HWND hDlgPrint_);

    virtual long   InstantiateChildren( );
    virtual long   InstantiateColumns( );
    virtual long   InstantiateFonts( );
    virtual long   InstantiatePens( );

  protected:
    virtual long   Initialize( );
    virtual long   PrintPage( );

    HWND  hDlgPrint;

  private:
  };


class ORLayer_PTitle : public ORLayer
  {
  public:
    ORLayer_PTitle( ORReport_PackList *pRepPackList_);

    virtual long PostPrint( ORDC *pDC);

  protected:
    virtual long InstantiateChildren( );

  private:
  };


class ORLayer_BillShip : public ORLayer
  {
  public:
    ORLayer_BillShip( ORReport_PackList *pRepPackList_,
                      PackingList *pPackList_);

    virtual long PostPrint( ORDC *pDC);

  protected:
    virtual long InstantiateChildren( );
    virtual long SizeAndPosition_Elems_CalcHt( );

  private:
    PackingList  *pPackList;
  };


class ORLayer_Spacer : public ORLayer
  {
  public:
    ORLayer_Spacer( ORReport_PackList *pRepPackList_,
                    int nType_, PackingList *pPackList_,
                    int nMarginTop_, int nMarginBottom_);

    virtual long   InstantiateChildren( );
    virtual long   PrePrint( ORDC *pDC);

  protected:
  private:
    PackingList  *pPackList;
    int           nType;
  };


class ORLayer_Items : public ORLayer
  {
  public:
    ORLayer_Items( ORReport_PackList *pRepPackList_, PackingList *pPackList_);

    virtual long   InstantiateChildren( );
    virtual long   PostPrint( ORDC *pDC);

  protected:
  private:
    PackingList  *pPackList;
  };


class ORLayer_Item : public ORLayer
  {
  public:
    ORLayer_Item( ORLayer *pParentLayer_, PackingList *pPackList_, int nItem_);

    virtual long   InstantiateChildren( );
    virtual long   PostPrint( ORDC *pDC);

  protected:
  private:
    PackingList *pPackList;
    int          nItem;
  };


class ORLayer_Total : public ORLayer
  {
  public:
    ORLayer_Total( ORReport_PackList *pRepPackList_, PackingList *pPackList_);

    virtual long   InstantiateChildren( );
    virtual long   PostPrint( ORDC *pDC);

  protected:
  private:
    PackingList  *pPackList;
  };


class ORLayer_CompanyInfo : public ORLayer
  {
  public:
    ORLayer_CompanyInfo( ORReport_PackList *pRepPackList_);

    virtual long   InstantiateChildren( );

  protected:
  private:
  };


#endif    //---- _ORPACKLS_H
