/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORPEN_H
#define  _ORPEN_H


#include <iostream.h>
#include "orobject.h"


class OREXPORT ORContext;


class OREXPORT ORPen : public ORObject
  {
  public:
    ORPen( ORContext *pParentContext_, long lId_,
           int nPenStyle_, int nPixWidth_, COLORREF clrPen_,
           double dPointsWidth = 0.0);
    ORPen( ORContext *pParentContext_, long lId_,
           LOGPEN &stLP_, double dPointsWidth = 0.0);
    ORPen( ORContext *pParentContext_, istream &is);
    virtual ~ORPen( );

            ORBool Save( ostream &os);
    virtual ORBool TypeOf( long lType);

    virtual HPEN   Handle( )                    { return hPen; }
            ORPen *Next( )                      { return (ORPen *)pNext; }
            ORPen *Prev( )                      { return (ORPen *)pPrev; }
    virtual long   Type( )                      { return TYPE_ORPEN; }
    virtual long   Width( short = OROUTSIDE)    { return stLP.lopnWidth.x; }

  protected:
    ORContext *pParentContext;
    LOGPEN     stLP;
    HPEN       hPen;
    double     dPointsWidth;

            void   CreatePen( );
            ORBool Load( istream &is);

  private:
  };


#endif    //---- _ORPEN_H
