/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORPREV_H
#define  _ORPREV_H


#include <fstream.h>
#include "orcontxt.h"


//---- predefined preview display modes
#define  ORDISP_FULLPAGE             1
#define  ORDISP_SCREENPAGEWIDTH      2
#define  ORDISP_SCREENPAGEHEIGHT     3
#define  ORDISP_WINDOWPAGEWIDTH      4
#define  ORDISP_WINDOWPAGEHEIGHT     5


#define  ORSHADOWDEPTH          50


class OREXPORT ORPreviewDC;
class OREXPORT ORPrintDC;


class OREXPORT ORPreviewWnd : public ORContext
  {
  public:
    ORPreviewWnd( HWND _hWnd);
    virtual ~ORPreviewWnd( );

    void   Close( );
    int    GetNewScrollPos( HWND hWnd, int nWhichScroller,
                            WPARAM wParam, LPARAM lParam);
    void   Invalidate( );
    ORBool IsOpen( );
    long   Open( char *psFile);
    long   PageGoto( short shPage);
    long   PageNext( );
    long   PagePrev( );
    long   Paint( );
    long   Print( ORPrintDC *pPrintDC);
    int    ScrollMaxX( );
    int    ScrollMaxY( );
    void   SetDisplayMode( short shMode);
    long   ViewDown( short shPixels);
    long   ViewHome( );
    long   ViewLeft( short shPixels);
    long   ViewRight( short shPixels);
    long   ViewUp( short shPixels);
    long   ViewX( long lDX);
    long   ViewY( long lDY);
    void   Zoom( short shPercent);

    char  *DocName( )                          { return sDocName; }
    HWND   Handle( )                           { return hWnd; }
    long   PaperHeight( )                      { return lPaperHeight; }
    long   PaperWidth( )                       { return lPaperWidth; }
    short  Zoom( )                             { return shZoomPercent; }

  protected:
    HWND   hWnd;

    char      sPreviewFile[MAXORPATH+1];
    ifstream  is;

    short  shPage;
    short  shNPages;
    short  shZoomPercent;
    short  shDisplayMode;

    char   sDocName[MAXDITITLE+1];
    char   sDriver[MAXORDCSTRING+1];
    char   sPrinter[MAXORDCSTRING+1];
    char   sPort[MAXORDCSTRING+1];

    long   lPaperHeight,
           lPaperWidth,
           lPrintableHeight,
           lPrintableWidth,
           lOrgX,
           lOrgY,
           lExtX,
           lExtY,
           lPageExtX,
           lPageExtY;
    short  shLogPixelsX;
    short  shLogPixelsY;

            long   CountPages( );
            long   DoPaint( );
    virtual long   Draw_Object( long lType);
            long   Draw_OREndDoc( );
            long   Draw_OREndPage( );
            long   Draw_ORLineTo( );
            long   Draw_ORMoveToEx( );
            long   Draw_ORRectangle( );
            long   Draw_ORRoundRect( );
            long   Draw_ORSelectBrush( );
            long   Draw_ORSelectFont( );
            long   Draw_ORSelectPen( );
            long   Draw_ORSelectStockBrush( );
            long   Draw_ORSelectStockFont( );
            long   Draw_ORSelectStockPen( );
            long   Draw_ORSetBkMode( );
            long   Draw_ORSetTextAlign( );
            long   Draw_ORStartDoc( );
            long   Draw_ORStartPage( );
            long   Draw_ORTextOut( );
    virtual long   DrawPage( short shPage);
            long   DrawPaper( );
            void   Init( );
            long   LoadBrush( );
            long   LoadFont( );
            long   LoadInfo( ORPreviewDC *pPrevDC);
            long   LoadPen( );
            long   PositionStreamPage( short shPage);
            long   PrintPages( ORPrintDC *pPrintDC);
            void   Reset( );
    virtual long   SetupDisplayMode( );

    long   MarginBottom( )    { return (lPaperHeight - lPrintableHeight) / 2; }
    long   MarginLeft( )        { return (lPaperWidth - lPrintableWidth) / 2; }
    long   MarginRight( )       { return (lPaperWidth - lPrintableWidth) / 2; }
    long   MarginTop( )       { return (lPaperHeight - lPrintableHeight) / 2; }

  private:
  };


#endif    //---- _ORPREV_H
