/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORPRNTDC_H
#define  _ORPRNTDC_H


#include <fstream.h>
#include "ordc.h"


class OREXPORT ORPrintDC : public ORDC
  {
  public:
    ORPrintDC( char *psDriver, char *psPrinterName, char *psPort,
               char *psPreviewFile = NULL);
    virtual ~ORPrintDC( );

    virtual long   AbortDoc( );
    virtual long   EndDoc( );
    virtual long   EndPage( );
    virtual long   LineTo( long lX, long lY);
    virtual long   MoveToEx( long lX, long lY, POINT *pPoint = NULL);
    virtual long   Rectangle( long lLeft, long lTop,
                              long lRight, long lBottom);
    virtual long   RoundRect( long lLeft, long lTop, long lRight, long lBottom,
                              long lEllipseWidth = 30,
                              long lEllipseHeight = 30);
    virtual long   SaveGDIObjects( ORBrush *pBrushes, ORFont *pFonts,
                                   ORPen *pPens);
    virtual HBRUSH Select( ORBrush *pBrush);
    virtual HFONT  Select( ORFont *pFont);
    virtual HPEN   Select( ORPen *pPen);
    virtual HBRUSH SelectStockBrush( int nStockBrush);
    virtual HFONT  SelectStockFont( int nStockFont);
    virtual HPEN   SelectStockPen( int nStockPen);
    virtual long   SetAbortProc( ABORTPROC lpProcAbort);
    virtual long   SetBkMode( int nBkMode);
            void   SetPreviewFile( char *psPreviewFile);
    virtual long   SetTextAlign( UINT uTA);
    virtual long   StartDoc( DOCINFO &stDocInfo);
    virtual long   StartPage( );
    virtual long   TextOut( long lX, long lY, char *psText, int nChars);
    virtual ORBool TypeOf( long lType);

    virtual long   Type( )                        { return TYPE_ORPRINTDC; }

    static ORPrintDC  *GetDefaultPrinterDC( );

  protected:
    char     sDriver[MAXORDCSTRING+1];
    char     sPrinter[MAXORDCSTRING+1];
    char     sPort[MAXORDCSTRING+1];

    char      sPreviewFile[MAXORPATH+1];
    ofstream  os;
    ORBool    bBetweenPages;

    //---- bufferable commands
    int       nBufferedBkMode;

    long    FlushBufferedCommands( );

  private:
  };


#endif    //---- _ORPRNTDC_H
