/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORREPORT_H
#define  _ORREPORT_H


#include "orcolumn.h"
#include "orcontxt.h"
#include "orlayer.h"


class OREXPORT ORPrintDC;


class OREXPORT ORReport : public ORContext
  {
  public:
    virtual ~ORReport( );

            ORColumn *Column( long lId);
    virtual long   HandleError( long lErr, char *psErr);
    virtual long   Instantiate( ORPrintDC *pPrintDC);
            long   IsPageFull( ORBool bForcePageEject_);

    virtual long   InstantiateBrushes( )         { return 0; }
    virtual long   InstantiateChildren( )        { return 0; }
    virtual long   InstantiateColumns( )         { return 0; }
    virtual long   InstantiateFonts( )           { return 0; }
    virtual long   InstantiatePageLayers( )      { return 0; }
    virtual long   InstantiatePens( )            { return 0; }
            short  Page( )                       { return shPage; }

  protected:
    ABORTPROC  lpProcAbort;
    ORColumn  *pColumns;
    ORLayer   *pLayers,
              *pPageLayers_Top,*pPageLayers_Bottom;
    char       sTitle[MAXDITITLE+1],
               sDocInfoOutput[MAXORPATH+1];
    ORBool     bPageLayersInstantiated;
    long       lErrOther;
    short      shPage;

    ORReport( char *psTitle_ = NULL, ABORTPROC lpProcAbort_ = NULL,
              char *psDocInfoOutput = NULL);

    virtual void   AddColumn( ORColumn *pColumn);
    virtual void   AddLayer( ORLayer *pLayer);
            void   AddPageLayer( ORLayer *pL);
            void   AdjustPageLayers_Bottom( ORRect &rectRemain);
            long   CallInstantiatePageLayers( );
            void   Clear( );
    virtual void   DeletePrinted( );
    virtual long   GetPrintableArea( ORRect &rect);
    virtual long   PrintPage( );
            long   SizeAndPositionColumns( );
            long   SizeAndPositionLayers( ORBool bForcePageEject,
                                          ORBool &bPageEject);

    virtual long   Initialize( )                 { return 0; }

  private:
  };


#endif    //---- _ORREPORT_H
