/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/

#include "orcc.h"
#include <windows.h>
#pragma  hdrstop

#include <stdio.h>
#include "orcolumn.h"
#include "ordc.h"
#include "ordemo.h"
#include "orfont.h"
#include "orlayer.h"
#include "orsales.h"
#include "ortext.h"
#include "sales.h"


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ORLayer_SHeader::ORLayer_SHeader( ORReport *pRep, long lAttr_)
                :ORLayer( pRep, lAttr_)
  {
  }

long ORLayer_SHeader::InstantiateChildren( )
  {
  long lErr = 0;

  ORLayer *pL = new ORLayer( this);
  new ORText( pL, 1, "Printed by:\nFor:", IDFntS_CourNew12, ORPOS_LEFT);
  new ORText( pL, 0, "Sales\nMarketing", IDFntS_CourNew12, ORPOS_RIGHT, 1);

  new ORText( pL, 2, "05/10/95\n12:00a", IDFntS_CourNew12, (ORPOS_RIGHT | ORJUST_RIGHT));
  new ORText( pL, 0, "Date:\nTime:", IDFntS_CourNew12, ORPOS_LEFT, 2);

  new ORText( pL, 0, "Eclectics Inc", IDFntS_Arial18, (ORPOS_CENTER | ORPOS_BOTTOM));

  pL = new ORLayer( this);
  new ORText( pL, 0, "Sales by Month by Product", IDFntS_Arial12, ORPOS_CENTER);

  pL = new ORLayer( this, 9, 9);
  new ORText( pL, 3, "RelDemo", IDFntS_Arial42, ORPOS_CENTER);
    new ORText( pL, 0, "TL", IDFntS_CourNew7p5, (ORPOS_TOP | ORPOS_LEFT), 3);
    new ORText( pL, 0, "TR", IDFntS_CourNew7p5, (ORPOS_TOP | ORPOS_RIGHT), 3);
    new ORText( pL, 0, "BL", IDFntS_CourNew7p5, (ORPOS_BOTTOM | ORPOS_LEFT), 3);
    new ORText( pL, 0, "BR", IDFntS_CourNew7p5, (ORPOS_BOTTOM | ORPOS_RIGHT), 3);
    new ORText( pL, 0, "Tl", IDFntS_CourNew7p5, (ORPOS_TOP | ORPOS_CENTER | ORJUST_LEFT), 3);
    new ORText( pL, 0, "Tc", IDFntS_CourNew7p5, (ORPOS_TOP | ORPOS_CENTER | ORJUST_CENTER), 3);
    new ORText( pL, 0, "Tr", IDFntS_CourNew7p5, (ORPOS_TOP | ORPOS_CENTER | ORJUST_RIGHT), 3);
    new ORText( pL, 0, "Lt", IDFntS_CourNew7p5, (ORPOS_LEFT | ORPOS_MIDDLE | ORJUST_TOP), 3);
    new ORText( pL, 0, "Lm", IDFntS_CourNew7p5, (ORPOS_LEFT | ORPOS_MIDDLE | ORJUST_MIDDLE), 3);
    new ORText( pL, 0, "Lb", IDFntS_CourNew7p5, (ORPOS_LEFT | ORPOS_MIDDLE | ORJUST_BOTTOM), 3);
    new ORText( pL, 0, "Bl", IDFntS_CourNew7p5, (ORPOS_BOTTOM | ORPOS_CENTER | ORJUST_LEFT), 3);
    new ORText( pL, 0, "Bc", IDFntS_CourNew7p5, (ORPOS_BOTTOM | ORPOS_CENTER | ORJUST_CENTER), 3);
    new ORText( pL, 0, "Br", IDFntS_CourNew7p5, (ORPOS_BOTTOM | ORPOS_CENTER | ORJUST_RIGHT), 3);
    new ORText( pL, 0, "Rt", IDFntS_CourNew7p5, (ORPOS_RIGHT | ORPOS_MIDDLE | ORJUST_TOP), 3);
    new ORText( pL, 0, "Rm", IDFntS_CourNew7p5, (ORPOS_RIGHT | ORPOS_MIDDLE | ORJUST_MIDDLE), 3);
    new ORText( pL, 0, "Rb", IDFntS_CourNew7p5, (ORPOS_RIGHT | ORPOS_MIDDLE | ORJUST_BOTTOM), 3);

  //---- column headers
  pL = new ORLayer( this);
  new ORText( pL, 0, "Month",   IDFntS_CourNew12, (ORPOS_CENTER | ORJUST_LEFT), IDColS_Month);
  new ORText( pL, 0, "Product", IDFntS_CourNew12, (ORPOS_CENTER | ORJUST_LEFT), IDColS_Product);

  new ORText( pL, 0, "Units", IDFntS_CourNew12, (ORPOS_CENTER | ORJUST_RIGHT), IDColS_Units);
  new ORText( pL, 0, "Price", IDFntS_CourNew12, (ORPOS_CENTER | ORJUST_RIGHT), IDColS_Price);
  new ORText( pL, 0, "Total", IDFntS_CourNew12, (ORPOS_CENTER | ORJUST_RIGHT), IDColS_Total);

  return lErr;
  }


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ORLayer_Footer::ORLayer_Footer( ORReport *pRep, long lAttr_)
               :ORLayer( pRep, lAttr_)
  {
  }

long ORLayer_Footer::InstantiateChildren( )
  {
  new ORText( this, 0, "Bottom\nLeft",  IDFntS_CourNew12, ORPOS_LEFT);
  new ORText( this, 0, "Bottom\nRight", IDFntS_CourNew12, (ORPOS_RIGHT | ORJUST_RIGHT));

  char  s[21];
  sprintf( s, "Page %d", Report( )->Page( ));
  new ORText( this, 0, s, IDFntS_CourNew12, (ORPOS_CENTER | ORPOS_BOTTOM));

  return 0;
  }


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ORLayer_Product::ORLayer_Product( ORLayer_Month *pLayerMonth_,
                                  Product *pProduct_)
                :ORLayer( pLayerMonth_)
  {
  pProduct    = pProduct_;
  pLayerMonth = pLayerMonth_;
  }

long ORLayer_Product::InstantiateChildren( )
  {
  long lErr = 0;

  new ORText( this, 0, pProduct->sProduct, IDFntS_Arial12, ORPOS_CENTER | ORJUST_LEFT, IDColS_Product);

  char  s[11];
  sprintf( s, "%d", pProduct->nUnits);
  new ORText( this, 0, s, IDFntS_Arial12, ORPOS_CENTER | ORJUST_RIGHT, IDColS_Units);

  sprintf( s, "$%d", pProduct->nPrice);
  new ORText( this, 0, s, IDFntS_Arial12, ORPOS_CENTER | ORJUST_RIGHT, IDColS_Price);

  long lTotal = (long)pProduct->nUnits * pProduct->nPrice;
  sprintf( s, "$%ld", lTotal);
  new ORText( this, 0, s, IDFntS_Arial12, ORPOS_CENTER | ORJUST_RIGHT, IDColS_Total);

  pLayerMonth->AddMonthTotal( lTotal);

  return lErr;
  }


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ORLayer_Month::ORLayer_Month( ORLayer_Body *pLayerBody_, Month *pMonth_)
              :ORLayer( pLayerBody_)
  {
  pMonth     = pMonth_;
  pLayerBody = pLayerBody_;

  lMonthTotal = 0;

  Breakable( FALSE);
  CheckPageFull( TRUE);
  }

long ORLayer_Month::InstantiateChildren( )
  {
  long lErr = 0;

  ORLayer *pL = new ORLayer( this, 0, 0, TRUE);
  new ORText( pL, 0, pMonth->sMonth, IDFntS_Arial12, (ORPOS_CENTER | ORJUST_LEFT), IDColS_Month);

  for (int i=0; i<pMonth->nProducts && !lErr; i++)
    {
    ORLayer_Product *pL = new ORLayer_Product( this, &pMonth->paProducts[i]);
    pL->StringId( pMonth->paProducts[i].sProduct);
    if (pL)
      lErr = pL->Instantiate( );
    }

  if (!lErr)
    {
    pL = new ORLayer( this);
    char  s[11];
    sprintf( s, "$%ld", lMonthTotal);
    new ORText( pL, 1, s, IDFntS_Arial12, (ORPOS_CENTER | ORJUST_RIGHT), IDColS_Total);
    new ORText( pL, 0, "Total: ", IDFntS_Arial12, ORPOS_LEFT, 1);
    }

  pLayerBody->AddGrandTotal( lMonthTotal);

  return lErr;
  }

void ORLayer_Month::AddMonthTotal( long l)
  {
  lMonthTotal += l;
  }


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ORLayer_Body::ORLayer_Body( ORReport_Sales *pRepSales_)
             :ORLayer( pRepSales_)
  {
  pRepSales = pRepSales_;

  lGrandTotal = 0;

//  Breakable( FALSE);
  CheckPageFull( TRUE);
  }

long ORLayer_Body::InstantiateChildren( )
  {
  long lErr = 0;

  while (!lErr)
    {
    if (pRepSales->NextMonth( ) == APPERR_NOMORE)
      break;

    ORLayer_Month *pL = new ORLayer_Month( this, pRepSales->GetMonth( ));
    pL->StringId( pRepSales->GetMonth( )->sMonth);
    if (pL)
      lErr = pL->Instantiate( );
    }

  if (!lErr)
    {
    ORLayer *pL = new ORLayer( this);
    char  s[11];
    sprintf( s, "$%ld", lGrandTotal);
    new ORText( pL, 1, s, IDFntS_Arial12, (ORPOS_CENTER | ORJUST_RIGHT), IDColS_Total);
    new ORText( pL, 0, "Grand Total: ", IDFntS_Arial12, ORPOS_LEFT, 1);
    }

  return lErr;
  }

void ORLayer_Body::AddGrandTotal( long l)
  {
  lGrandTotal += l;
  }


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ORReport_Sales::ORReport_Sales( char *psTitle, ABORTPROC lpfnAbortProc_,
                                HWND hDlgPrint_)
               :ORReport( psTitle, lpfnAbortProc_)
  {
  hDlgPrint = hDlgPrint_;
  }

long ORReport_Sales::Initialize( )
  {
  SendMessage( hDlgPrint, WMU_TITLE, 0, (LPARAM)sTitle);

  long lErr = ORReport::Initialize( );

  if (!lErr)
    pDC->SetBkMode( TRANSPARENT);

  return lErr;
  }

long ORReport_Sales::Instantiate( ORPrintDC *pPrintDC)
  {
  long lErr = 0;

  //---- verify data file exists
  FILE *pF = fopen( FILE_SALES_DATA, "rt");
  if (pF == NULL)
    {
    char  s[101];
    sprintf( s, "Required data file '%s' does not exist.", FILE_SALES_DATA);
    MessageBox( hDlgPrint, s, NULL, MB_ICONSTOP);
    lErr = APPERR_FILE;
    }

  if (pF)
    fclose( pF);

  if (!lErr)
    lErr = ORReport::Instantiate( pPrintDC);

  return lErr;
  }

long ORReport_Sales::InstantiateColumns( )
  {
  new ORColumn( this, IDColS_Month,   "  Month  ",   IDFntS_CourNew12, 0, 0, 0, ORPOS_LEFT);
  new ORColumn( this, IDColS_Product, "  Product  ", IDFntS_CourNew12, 5, 0, IDColS_Month, ORPOS_RIGHT);

  new ORColumn( this, IDColS_Total, "  Total  ", IDFntS_CourNew12, 0, 0, 0, ORPOS_RIGHT);
  new ORColumn( this, IDColS_Price, "  Price  ", IDFntS_CourNew12, 0, 5, IDColS_Total, ORPOS_LEFT);
  new ORColumn( this, IDColS_Units, "  Units  ", IDFntS_CourNew12, 0, 5, IDColS_Price, ORPOS_LEFT);

  return 0;
  }

/*-----------------------------------------------------------------------------
  these long, detailed calls to create ORFonts are not always required.  they
    are used here because the ORDemo.Exe program can be run on a variety of
    different machines with different fonts available.  by providing the
    Windows font mapper with the maximum amount of information, it will be
    able to provide a similar font if the desired font is not available.
    if you know ahead of time what fonts will be available when your reports
    are printed, you can simply create your fonts in the
    ORReport::InstantiateFonts member function as follows:
      new ORFont( this, IDFntA_Arial10,  "Arial", 10.0);
      new ORFont( this, IDFntA_Arial10B, "Arial", 10.0, 0, 0, 0, FW_BLACK);
-----------------------------------------------------------------------------*/
long ORReport_Sales::InstantiateFonts( )
  {
  new ORFont( this, IDFntS_Arial12, "Arial", 12.0, 0.0, 0, 0, FW_NORMAL,
              0, 0, 0, 0, OUT_DEFAULT_PRECIS,
              CLIP_DEFAULT_PRECIS, PROOF_QUALITY, (VARIABLE_PITCH | FF_SWISS));
  new ORFont( this, IDFntS_Arial18, "Arial", 18.0, 0.0, 0, 0, FW_NORMAL,
              0, 0, 0, 0, OUT_DEFAULT_PRECIS,
              CLIP_DEFAULT_PRECIS, PROOF_QUALITY, (VARIABLE_PITCH | FF_SWISS));
  new ORFont( this, IDFntS_Arial42, "Arial", 42.0, 0.0, 0, 0, FW_NORMAL,
              0, 0, 0, 0, OUT_DEFAULT_PRECIS,
              CLIP_DEFAULT_PRECIS, PROOF_QUALITY, (VARIABLE_PITCH | FF_SWISS));
  new ORFont( this, IDFntS_CourNew12, "Courier New", 12.0, 0.0, 0, 0, FW_NORMAL,
              0, 0, 0, 0, OUT_DEFAULT_PRECIS,
              CLIP_DEFAULT_PRECIS, PROOF_QUALITY, (FIXED_PITCH | FF_SWISS));
  new ORFont( this, IDFntS_CourNew7p5, "Courier New", 7.5, 0.0, 0, 0, FW_NORMAL,
              0, 0, 0, 0, OUT_DEFAULT_PRECIS,
              CLIP_DEFAULT_PRECIS, PROOF_QUALITY, (FIXED_PITCH | FF_SWISS));

  return 0;
  }

long ORReport_Sales::InstantiateChildren( )
  {
  long lErr = 0;

  isSales.open( FILE_SALES_DATA);
  if (isSales.bad( ))
    lErr = APPERR_FILE;

  if (!lErr)
    {
    ORLayer_Body *pL = new ORLayer_Body( this);
    if (pL)
      lErr = pL->Instantiate( );
    }

  isSales.close( );

  return lErr;
  }

long ORReport_Sales::InstantiatePageLayers( )
  {
  long lErr = 0;

  //---- add header page layer
  if (!lErr)
    {
    ORLayer_SHeader *pL = new ORLayer_SHeader( this, ORPOS_TOP);
    if (pL)
      lErr = pL->Instantiate( );
    }

  //---- add footer page layer
  if (!lErr)
    {
    ORLayer_Footer *pL = new ORLayer_Footer( this, ORPOS_BOTTOM);
    if (pL)
      lErr = pL->Instantiate( );
    }

  return lErr;
  }

long ORReport_Sales::PrintPage( )
  {
  char  s[51];
  sprintf( s, "Printing page %d", shPage);
  SendMessage( hDlgPrint, WMU_PRINTINGPAGE, 0, (LPARAM)s);

  long lErr = ORReport::PrintPage( );

  sprintf( s, "Initializing page %d", shPage);
  SendMessage( hDlgPrint, WMU_PRINTINGPAGE, 0, (LPARAM)s);

  return lErr;
  }

long ORReport_Sales::NextMonth( )
  {
  isSales >> oMonth;

  if (isSales.eof( ))
    return APPERR_NOMORE;

  return 0;
  }
