/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORSALES_H
#define  _ORSALES_H


#include <fstream.h>
#include "orreport.h"
#include "sales.h"


//---- developer defined Font Ids
#define  IDFntS_Arial12         1101
#define  IDFntS_Arial18         1102
#define  IDFntS_Arial42         1103
#define  IDFntS_CourNew12       1104
#define  IDFntS_CourNew7p5      1105

//---- developer defined Column Ids
#define  IDColS_Month        1201
#define  IDColS_Product      1202
#define  IDColS_Units        1203
#define  IDColS_Price        1204
#define  IDColS_Total        1205

#define  FILE_SALES_DATA     "Sales.Txt"


class OREXPORT ORReport_Sales : public ORReport
  {
  public:
    ORReport_Sales( char *psTitle_, ABORTPROC lpfnAbortProc_, HWND hDlgPrint_);

    virtual long   Instantiate( ORPrintDC *pPrintDC);
    virtual long   InstantiateColumns( );
    virtual long   InstantiateFonts( );
    virtual long   InstantiateChildren( );
    virtual long   InstantiatePageLayers( );

            Month *GetMonth( )                         { return &oMonth; }
            long   NextMonth( );

  protected:
    virtual long   Initialize( );
    virtual long   PrintPage( );

    ifstream  isSales;
    Month     oMonth;
    HWND      hDlgPrint;

  private:
  };


class ORLayer_SHeader : public ORLayer
  {
  public:
    ORLayer_SHeader( ORReport *pRep, long lAttr_ = 0);

    virtual long   InstantiateChildren( );

    virtual char  *Name( )                   { return "ORLayer_SHeader"; }

  protected:
  private:
  };


class ORLayer_Footer : public ORLayer
  {
  public:
    ORLayer_Footer( ORReport *pRep, long lAttr_ = 0);

    virtual long   InstantiateChildren( );

    virtual char  *Name( )                   { return "ORLayer_Footer"; }

  protected:
  private:
  };


class ORLayer_Body : public ORLayer
  {
  public:
    ORLayer_Body( ORReport_Sales *pRepSales);

            void   AddGrandTotal( long l);
    virtual long   InstantiateChildren( );

    virtual char  *Name( )                   { return "ORLayer_Body"; }

  protected:
  private:
    ORReport_Sales  *pRepSales;
    long             lGrandTotal;
  };


class ORLayer_Month : public ORLayer
  {
  public:
    ORLayer_Month( ORLayer_Body *pLayerBody, Month *pMonth);

            void   AddMonthTotal( long l);
    virtual long   InstantiateChildren( );

    virtual char  *Name( )                   { return "ORLayer_Month"; }

  protected:
  private:
    Month         *pMonth;
    ORLayer_Body  *pLayerBody;
    long  lMonthTotal;
  };


class ORLayer_Product : public ORLayer
  {
  public:
    ORLayer_Product( ORLayer_Month *pLayerMonth, Product *pProduct);

    virtual long   InstantiateChildren( );

    virtual char  *Name( )                   { return "ORLayer_Product"; }

  protected:
  private:
    Product        *pProduct;
    ORLayer_Month  *pLayerMonth;
  };


#endif    //---- _ORSALES_H
