/*
[]===========================================================================[]
||                                                                           ||
||                            Object Reports 1.1                             ||
||                (C) Copyright RollinSoftware Inc 1995,1996                 ||
||                                                                           ||
[]===========================================================================[]
*/


#ifndef  _ORTEXT_H
#define  _ORTEXT_H


#include "orelemnt.h"


class OREXPORT ORFont;
class OREXPORT ORLayer;


class OREXPORT ORText : public ORElement
  {
  public:
    ORText( ORLayer *pParentLayer_, long lId_, char *psText_, long lFontId_,
            long lAttr_ = 0, long lRelId_ = 0);
    virtual ~ORText( );

    virtual long   Print( ORDC *pDC);
            void   SetMaxWidth( ORObject *pObj);
            long   SetMaxWidth( char *psMaxWidth_, long lMaxWidthFontId = 0);
            void   SetMaxWidthPix( long lMaxWidthPix_);
            void   SetMaxWidthPts( long lMaxWidthPts_);
            ORBool Text( char *psText_);
    virtual ORBool TypeOf( long lType);

            ORText *Next( )               { return (ORText *)pNext; }
            ORText *Prev( )               { return (ORText *)pPrev; }
            char  *Text( )                { return psText; }
    virtual long   Type( )                { return TYPE_ORTEXT; }

    virtual char  *Name( )                { return "ORText"; }

  protected:
    char     *psText;
    ORFont   *pFont;
    char     *psMaxWidthText;
    ORObject *pMaxWidthObj;
    ORFont   *pMaxWidthFont;
    long      lMaxWidthPts,
              lMaxWidthPix;

            long   CalcTextExtent( SIZE &size, ORDC *pDC);
            long   MaxWidth( ORDC *pDC);
    virtual void   SetDefaultAttr( );
    virtual long   Size_Self( ORRect &rectRemain, ORDC *pDC);
            char  *StringBreak( ORDC *pDC, char *psStart, int &nChars,
                                long &lError);
            ORBool StringBreak_Hard( char c);
            ORBool StringBreak_WordChar( char c);

  private:
  };


#endif    //---- _ORTEXT_H
